// opcodetest.cpp : Defines the entry point for the console application.
//

#include "opcode.h"

// 1Ʈ OPCODE鿡  
OPCODELIST Opcode1Lists[] = {
    {0x37, 1, 1, 0},      // AAA(1)
    {0xD5, 2, 2, 0},      // AAD(PENTIUM, IMM8, 2), AAD(NO PENTIUM:D50A)
    {0xD4, 2, 2, 0},      // AAM(PENTIUM, IMM8, 2), AAM(NO PENTIUM:D40A)
    {0x3F, 1, 1, 0},      // AAS(1)
    {0x12, 2, 2, 1},      // ADC(2)
    {0x13, 2, 2, 1},      // ADC(2)
    {0x10, 2, 2, 1},      // ADC(2)
    {0x11, 2, 2, 1},      // ADC(2)
    {0x14, 2, 2, 0},      // ADC(2)
    {0x15, 3, 5, 0},      // ADC(3)
    {0x82, 3, 3, 1},      // ADC(3), ADD, AND, CMP, OR, SBB, SUB, XOR
    {0x83, 3, 3, 1},      // ADC(3), ADD, AND, CMP, OR, SBB, SUB, XOR
    {0x80, 3, 3, 1},      // ADC(3), ADD, AND, CMP, OR, SBB, SUB, XOR
    {0x81, 4, 6, 1},      // ADC(4), ADD, AND, CMP, OR, SBB, SUB, XOR
    {0x02, 2, 2, 1},      // ADD(2)
    {0x03, 2, 2, 1},      // ADD(2)
    {0x00, 2, 2, 1},      // ADD(2)
    {0x01, 2, 2, 1},      // ADD(2)
    {0x04, 2, 2, 0},      // ADD(2)
    {0x05, 3, 5, 0},      // ADD(3)
    {0x22, 2, 2, 1},      // AND(2)
    {0x23, 2, 2, 1},      // AND(2)
    {0x20, 2, 2, 1},      // AND(2)
    {0x21, 2, 2, 1},      // AND(2)
    {0x24, 2, 2, 0},      // AND(2)
    {0x25, 3, 5, 0},      // AND(3)
    {0x63, 2, 2, 1},      // ARPL(2)
    {0x62, 2, 2, 1},      // BOUND(2)
    {0x98, 1, 1, 0},      // CBW(1), CWDE(1)
    {0x99, 1, 1, 0},      // CDQ(1), CWD(1)
    {0xF8, 1, 1, 0},      // CLC(1)
    {0xFC, 1, 1, 0},      // CLD(1)
    {0xFA, 1, 1, 0},      // CLI(1)
    {0xF5, 1, 1, 0},      // CMC(1)
    {0x3A, 2, 2, 1},      // CMP(2)
    {0x3B, 2, 2, 1},      // CMP(2)
    {0x38, 2, 2, 1},      // CMP(2)
    {0x39, 2, 2, 1},      // CMP(2)
    {0x3C, 2, 2, 0},      // CMP(2)
    {0x3D, 3, 5, 0},      // CMP(3)
    {0xA6, 1, 1, 0},      // CMPSB(1)
    {0xA7, 1, 1, 0},      // CMPSW(1), CMPSD(1)
    {0x27, 1, 1, 0},      // DAA(1)
    {0x2F, 1, 1, 0},      // DAS(1)
    {0x48, 1, 1, 0},      // DEC(1)
    {0x49, 1, 1, 0},      // DEC(1)
    {0x4A, 1, 1, 0},      // DEC(1)
    {0x4B, 1, 1, 0},      // DEC(1)
    {0x4C, 1, 1, 0},      // DEC(1)
    {0x4D, 1, 1, 0},      // DEC(1)
    {0x4E, 1, 1, 0},      // DEC(1)
    {0x4F, 1, 1, 0},      // DEC(1)
    {0xFE, 2, 2, 1},      // DEC(2), INC, INVALID
    {0xFF, 2, 2, 1},      // DEC(2), INC, PUSH, CALL, JMP
    {0xF6, 2, 2, 1},      // DIV(2), IDIV, IMUL, MUL, NEG, NOT
    {0xF7, 2, 2, 1},      // DIV(2), IDIV, IMUL, MUL, NEG, NOT
    {0xC8, 4, 4, 0},      // ENTER(4)
    {0xF4, 1, 1, 0},      // HLT(1)
    {0x6B, 3, 3, 1},      // IMUL(3)
    {0x69, 4, 6, 1},      // IMUL(4)
    {0xE4, 2, 2, 0},      // IN(2)
    {0xE5, 2, 2, 0},      // IN(2)
    {0xEC, 1, 1, 0},      // IN(1)
    {0xED, 1, 1, 0},      // IN(1)
    {0x40, 1, 1, 0},      // INC(1)
    {0x41, 1, 1, 0},      // INC(1)
    {0x42, 1, 1, 0},      // INC(1)
    {0x43, 1, 1, 0},      // INC(1)
    {0x44, 1, 1, 0},      // INC(1)
    {0x45, 1, 1, 0},      // INC(1)
    {0x46, 1, 1, 0},      // INC(1)
    {0x47, 1, 1, 0},      // INC(1)
    {0x6C, 1, 1, 0},      // INSB(1)
    {0x6D, 1, 1, 0},      // INSW(1), INSD(1)
    {0xCC, 1, 1, 0},      // INT3(1)
    {0xCD, 2, 2, 0},      // INT(2)
    {0xCE, 1, 1, 0},      // INTO(1)
    {0xCF, 1, 1, 0},      // IRET(1), IRETD(1)
    {0x9F, 1, 1, 0},      // LAHF(1)
    {0xC5, 2, 2, 1},      // LDS(2)
    {0xC4, 2, 2, 1},      // LES(2)
    {0x8D, 2, 2, 1},      // LEA(2)
    {0xC9, 1, 1, 0},      // LEAVE(1)
    {0xAC, 1, 1, 0},      // LODSB(1)
    {0xAD, 1, 1, 0},      // LODSW(1)
    {0xA2, 3, 5, 0},      // MOV(3)
    {0xA3, 3, 5, 0},      // MOV(3)
    {0xA0, 3, 5, 0},      // MOV(3)
    {0xA1, 3, 5, 0},      // MOV(3)
    {0xB0, 2, 2, 0},      // MOV(2)
    {0xB1, 2, 2, 0},      // MOV(2)
    {0xB2, 2, 2, 0},      // MOV(2)
    {0xB3, 2, 2, 0},      // MOV(2)
    {0xB4, 2, 2, 0},      // MOV(2)
    {0xB5, 2, 2, 0},      // MOV(2)
    {0xB6, 2, 2, 0},      // MOV(2)
    {0xB7, 2, 2, 0},      // MOV(2)
    {0xB8, 3, 5, 0},      // MOV(3)
    {0xB9, 3, 5, 0},      // MOV(3)
    {0xBA, 3, 5, 0},      // MOV(3)
    {0xBB, 3, 5, 0},      // MOV(3)
    {0xBC, 3, 5, 0},      // MOV(3)
    {0xBD, 3, 5, 0},      // MOV(3)
    {0xBE, 3, 5, 0},      // MOV(3)
    {0xBF, 3, 5, 0},      // MOV(3)
    {0xC6, 3, 3, 1},      // MOV(3)
    {0xC7, 4, 6, 1},      // MOV(4)
    {0x8A, 2, 2, 1},      // MOV(2)
    {0x8B, 2, 2, 1},      // MOV(2)
    {0x88, 2, 2, 1},      // MOV(2)
    {0x89, 2, 2, 1},      // MOV(2)
    {0x8C, 2, 2, 1},      // MOV(2)
    {0x8E, 2, 2, 1},      // MOV(2)
    {0xA4, 1, 1, 0},      // MOSSB(1)
    {0xA5, 1, 1, 0},      // MOVSW(1), MOVSD(1)
    {0x90, 1, 1, 0},      // NOP(1)
    {0x0A, 2, 2, 1},      // OR(2)
    {0x0B, 2, 2, 1},      // OR(2)
    {0x08, 2, 2, 1},      // OR(2)
    {0x09, 2, 2, 1},      // OR(2)
    {0x0C, 2, 2, 0},      // OR(2)
    {0x0D, 3, 5, 0},      // OR(3)
    {0xE6, 2, 2, 0},      // OUT(2)
    {0xE7, 2, 2, 0},      // OUT(2)
    {0xEE, 1, 1, 0},      // OUT(1)
    {0xEF, 1, 1, 0},      // OUT(1)
    {0x6E, 1, 1, 0},      // OUTSB(1)
    {0x6F, 1, 1, 0},      // OUTSW(1), OUTSD(1)
    {0x58, 1, 1, 0},      // POP(1)
    {0x59, 1, 1, 0},      // POP(1)
    {0x5A, 1, 1, 0},      // POP(1)
    {0x5B, 1, 1, 0},      // POP(1)
    {0x5C, 1, 1, 0},      // POP(1)
    {0x5D, 1, 1, 0},      // POP(1)
    {0x5E, 1, 1, 0},      // POP(1)
    {0x5F, 1, 1, 0},      // POP(1)
    {0x8F, 2, 2, 1},      // POP(2)
    {0x07, 1, 1, 0},      // POP(1)
    {0x17, 1, 1, 0},      // POP(1)
    {0x1F, 1, 1, 0},      // POP(1)
    {0x37, 1, 1, 0},      // POP(1)
    {0x61, 1, 1, 0},      // POPA(1), POPAD(1)
    {0x9D, 1, 1, 0},      // POPF(1), POPFD(1)
    {0x50, 1, 1, 0},      // PUSH(1)
    {0x51, 1, 1, 0},      // PUSH(1)
    {0x52, 1, 1, 0},      // PUSH(1)
    {0x53, 1, 1, 0},      // PUSH(1)
    {0x54, 1, 1, 0},      // PUSH(1)
    {0x55, 1, 1, 0},      // PUSH(1)
    {0x56, 1, 1, 0},      // PUSH(1)
    {0x57, 1, 1, 0},      // PUSH(1)
    {0x06, 1, 1, 0},      // PUSH(1)
    {0x0E, 1, 1, 0},      // PUSH(1)
    {0x16, 1, 1, 0},      // PUSH(1)
    {0x1E, 1, 1, 0},      // PUSH(1)
    {0x6A, 2, 2, 0},      // PUSH(2)
    {0x68, 3, 5, 0},      // PUSH(3)
    {0x60, 1, 1, 0},      // PUSHA(1), PUSHAD(1)
    {0x9C, 1, 1, 0},      // PUSHF(1), PUSHFD(1)
    {0xD0, 2, 2, 1},      // RCL(2), RCR, ROL, ROR, SAL, SAR, SHL, SHR
    {0xD1, 2, 2, 1},      // RCL(2), RCR, ROL, ROR, SAL, SAR, SHL, SHR
    {0xD2, 2, 2, 1},      // RCL(2), RCR, ROL, ROR, SAL, SAR, SHL, SHR
    {0xD3, 2, 2, 1},      // RCL(2), RCR, ROL, ROR, SAL, SAR, SHL, SHR
    {0xC0, 3, 3, 1},      // RCL(3), RCR, ROL, ROR, SAL, SAR, SHL, SHR
    {0xC1, 3, 3, 1},      // RCL(3), RCR, ROL, ROR, SAL, SAR, SHL, SHR
    {0xC3, 1, 1, 0},      // RET(1)
    {0xC2, 3, 3, 0},      // RETN(3)
    {0xCB, 1, 1, 0},      // RETF(1)
    {0xCA, 3, 3, 0},      // RETNF(3)
    {0xD6, 1, 1, 0},      // SALC(1)
    {0x9E, 1, 1, 0},      // SAHF(1)
    {0x1A, 2, 2, 1},      // SBB(2)
    {0x1B, 2, 2, 1},      // SBB(2)
    {0x18, 2, 2, 1},      // SBB(2)
    {0x19, 2, 2, 1},      // SBB(2)
    {0x1C, 2, 2, 0},      // SBB(2)
    {0x1D, 3, 5, 0},      // SBB(3)
    {0xAE, 1, 1, 0},      // SCASB(1)
    {0xAF, 1, 1, 0},      // SCASW(1), SCASD(1)
    {0xF9, 1, 1, 0},      // STC(1)
    {0xFD, 1, 1, 0},      // STD(1)
    {0xFB, 1, 1, 0},      // STI(1)
    {0xAA, 1, 1, 0},      // STOSB(1)
    {0xAB, 1, 1, 0},      // STOSW(1), STOSD(1)
    {0x2A, 2, 2, 1},      // SUB(2)
    {0x2B, 2, 2, 1},      // SUB(2)
    {0x28, 2, 2, 1},      // SUB(2)
    {0x29, 2, 2, 1},      // SUB(2)
    {0x2C, 2, 2, 0},      // SUB(2)
    {0x2D, 3, 5, 0},      // SUB(3)
    {0x84, 2, 2, 1},      // TEST(2)
    {0x85, 2, 2, 1},      // TEST(2)
    {0xA8, 2, 2, 0},      // TEST(2)
    {0xA9, 3, 5, 0},      // TEST(3)
    {0x9B, 1, 1, 0},      // WAIT(1)
    {0x91, 1, 1, 0},      // XCHG(1)
    {0x92, 1, 1, 0},      // XCHG(1)
    {0x93, 1, 1, 0},      // XCHG(1)
    {0x94, 1, 1, 0},      // XCHG(1)
    {0x95, 1, 1, 0},      // XCHG(1)
    {0x96, 1, 1, 0},      // XCHG(1)
    {0x97, 1, 1, 0},      // XCHG(1)
    {0x86, 2, 2, 1},      // XCHG(2)
    {0x87, 2, 2, 1},      // XCHG(2)
    {0xD7, 1, 1, 0},      // XLAT(1)
    {0x32, 2, 2, 1},      // XOR(2)
    {0x33, 2, 2, 1},      // XOR(2)
    {0x30, 2, 2, 1},      // XOR(2)
    {0x31, 2, 2, 1},      // XOR(2)
    {0x34, 2, 2, 0},      // XOR(2)
    {0x35, 3, 5, 0},      // XOR(3)
    {0xE8, 3, 5, 0},      // CALL(Near, 3)
    {0x9A, 5, 7, 0},      // CALL(Far, 5)
    {0x70, 2, 2, 0},      // Jcc(2)
    {0x71, 2, 2, 0},      // Jcc(2)
    {0x72, 2, 2, 0},      // Jcc(2)
    {0x73, 2, 2, 0},      // Jcc(2)
    {0x74, 2, 2, 0},      // Jcc(2)
    {0x75, 2, 2, 0},      // Jcc(2)
    {0x76, 2, 2, 0},      // Jcc(2)
    {0x77, 2, 2, 0},      // Jcc(2)
    {0x78, 2, 2, 0},      // Jcc(2)
    {0x79, 2, 2, 0},      // Jcc(2)
    {0x7A, 2, 2, 0},      // Jcc(2)
    {0x7B, 2, 2, 0},      // Jcc(2)
    {0x7C, 2, 2, 0},      // Jcc(2)
    {0x7D, 2, 2, 0},      // Jcc(2)
    {0x7E, 2, 2, 0},      // Jcc(2)
    {0x7F, 2, 2, 0},      // Jcc(2)
    {0xE3, 2, 2, 0},      // JCXZ(2), JCXE, JECXZ, JECXE
    {0xEB, 2, 2, 0},      // JMP(Short, 2)
    {0xE9, 3, 5, 0},      // JMP(Near, 3)
    {0xEA, 5, 7, 0},      // JMP(Far, 5)
    {0xE2, 2, 2, 0},      // LOOP(Short, 2)
    {0xE1, 2, 2, 0},      // LOOPZ(Short, 2), LOOPE
    {0xE0, 2, 2, 0},      // LOOPNZ(Short, 2), LOOPNE
    {0xF0, 1, 1, 0},      // LOCK(1), LOCK:
    {0xF3, 1, 1, 0},      // REP(1), REPE, REPZ
    {0xF2, 1, 1, 0},      // REPNE(1), REPNZ
    {0x2E, 1, 1, 0},      // CS:(1)
    {0x3E, 1, 1, 0},      // DS:(1)
    {0x26, 1, 1, 0},      // ES:(1)
    {0x64, 1, 1, 0},      // FS:(1)
    {0x65, 1, 1, 0},      // GS:(1)
    {0x36, 1, 1, 0}       // SS:(1)
};

// 2Ʈ OPCODE鿡  (0F XX)
OPCODELIST Opcode2Lists[] = {
    {0xBC, 3, 3, 1},      // BSF(3)
    {0xBD, 3, 3, 1},      // BSR(3)
    {0xC8, 2, 2, 0},      // BSWAP(2)
    {0xC9, 2, 2, 0},      // BSWAP(2)
    {0xCA, 2, 2, 0},      // BSWAP(2)
    {0xCB, 2, 2, 0},      // BSWAP(2)
    {0xCC, 2, 2, 0},      // BSWAP(2)
    {0xCD, 2, 2, 0},      // BSWAP(2)
    {0xCE, 2, 2, 0},      // BSWAP(2)
    {0xCF, 2, 2, 0},      // BSWAP(2)
    {0xBA, 4, 4, 1},      // BT(4), BTC(4), BTR(4), BTS(4)
    {0xA3, 3, 3, 1},      // BT(3)
    {0xBB, 3, 3, 1},      // BTC(3)
    {0xB3, 3, 3, 1},      // BTR(3)
    {0xAB, 3, 3, 1},      // BTS(3)
    {0x06, 2, 2, 0},      // CLTS(2)
    {0x40, 3, 3, 1},      // CMOVcc(PentiumPro, 3)
    {0x41, 3, 3, 1},      // CMOVcc(PentiumPro, 3)
    {0x42, 3, 3, 1},      // CMOVcc(PentiumPro, 3)
    {0x43, 3, 3, 1},      // CMOVcc(PentiumPro, 3)
    {0x44, 3, 3, 1},      // CMOVcc(PentiumPro, 3)
    {0x45, 3, 3, 1},      // CMOVcc(PentiumPro, 3)
    {0x46, 3, 3, 1},      // CMOVcc(PentiumPro, 3)
    {0x47, 3, 3, 1},      // CMOVcc(PentiumPro, 3)
    {0x48, 3, 3, 1},      // CMOVcc(PentiumPro, 3)
    {0x49, 3, 3, 1},      // CMOVcc(PentiumPro, 3)
    {0x4A, 3, 3, 1},      // CMOVcc(PentiumPro, 3)
    {0x4B, 3, 3, 1},      // CMOVcc(PentiumPro, 3)
    {0x4C, 3, 3, 1},      // CMOVcc(PentiumPro, 3)
    {0x4D, 3, 3, 1},      // CMOVcc(PentiumPro, 3)
    {0x4E, 3, 3, 1},      // CMOVcc(PentiumPro, 3)
    {0x4F, 3, 3, 1},      // CMOVcc(PentiumPro, 3)
    {0xB0, 3, 3, 1},      // CMPXCHG(3)
    {0xB1, 3, 3, 1},      // CMPXCHG(3)
    {0xC7, 3, 3, 1},      // CMPXCHG8B(3)
    {0xA2, 2, 2, 0},      // CPUID(2)
    {0xAF, 3, 3, 1},      // IMUL(3)
    {0x08, 2, 2, 0},      // INVD(2)
    {0x02, 3, 3, 1},      // LAR(3)
    {0xB4, 3, 3, 1},      // LFS(3)
    {0xB5, 3, 3, 1},      // LGS(3)
    {0xB2, 3, 3, 1},      // LSS(3)
    {0x01, 3, 3, 1},      // LGDT(3), LIDT, LMSW, SGDT, SIDT, SMSW, INVLPG
    {0x00, 3, 3, 1},      // LLDT(3), LTR, SLDT, STR, VERR, VERW
    {0x03, 3, 3, 1},      // LSL(3)
    {0x20, 3, 3, 0},      // MOV(3)
    {0x22, 3, 3, 0},      // MOV(3)
    {0x21, 3, 3, 0},      // MOV(3)
    {0x23, 3, 3, 0},      // MOV(3)
    {0x24, 3, 3, 0},      // MOV(3)
    {0x26, 3, 3, 0},      // MOV(3)
    {0xBE, 3, 3, 1},      // MOVSX(3)
    {0xBF, 3, 3, 1},      // MOVSX(3)
    {0xB6, 3, 3, 1},      // MOVZX(3)
    {0xB7, 3, 3, 1},      // MOVZX(3)
    {0xA1, 2, 2, 0},      // POP(2)
    {0xA9, 2, 2, 0},      // POP(2)
    {0xA0, 2, 2, 0},      // PUSH(2)
    {0xA8, 2, 2, 0},      // PUSH(2)
    {0x32, 2, 2, 0},      // RDMSR(2)
    {0x51, 3, 3, 0},      // RDTSC(X) ==> ( SQRTXX, 3)
    {0x33, 2, 2, 0},      // RDPMC(2)
    {0xAA, 2, 2, 0},      // RSM(2)
    {0x90, 3, 3, 1},      // SETcc(3)
    {0x91, 3, 3, 1},      // SETcc(3)
    {0x92, 3, 3, 1},      // SETcc(3)
    {0x93, 3, 3, 1},      // SETcc(3)
    {0x94, 3, 3, 1},      // SETcc(3)
    {0x95, 3, 3, 1},      // SETcc(3)
    {0x96, 3, 3, 1},      // SETcc(3)
    {0x97, 3, 3, 1},      // SETcc(3)
    {0x98, 3, 3, 1},      // SETcc(3)
    {0x99, 3, 3, 1},      // SETcc(3)
    {0x9A, 3, 3, 1},      // SETcc(3)
    {0x9B, 3, 3, 1},      // SETcc(3)
    {0x9C, 3, 3, 1},      // SETcc(3)
    {0x9D, 3, 3, 1},      // SETcc(3)
    {0x9E, 3, 3, 1},      // SETcc(3)
    {0x9F, 3, 3, 1},      // SETcc(3)
    {0xA4, 4, 4, 1},      // SHLD(4)
    {0xA5, 3, 3, 1},      // SHLD(3)
    {0xAC, 4, 4, 1},      // SHRD(4)
    {0xAD, 3, 3, 1},      // SHRD(3)
    {0x09, 2, 2, 0},      // WBINVD(2)
    {0x30, 2, 2, 0},      // WRMSR(2)
    {0xC0, 3, 3, 1},      // XADD(3)
    {0xC1, 3, 3, 1},      // XADD(3)
    {0x80, 4, 6, 0},      // Jcc(Near, 4)
    {0x81, 4, 6, 0},      // Jcc(Near, 4)
    {0x82, 4, 6, 0},      // Jcc(Near, 4)
    {0x83, 4, 6, 0},      // Jcc(Near, 4)
    {0x84, 4, 6, 0},      // Jcc(Near, 4)
    {0x85, 4, 6, 0},      // Jcc(Near, 4)
    {0x86, 4, 6, 0},      // Jcc(Near, 4)
    {0x87, 4, 6, 0},      // Jcc(Near, 4)
    {0x88, 4, 6, 0},      // Jcc(Near, 4)
    {0x89, 4, 6, 0},      // Jcc(Near, 4)
    {0x8A, 4, 6, 0},      // Jcc(Near, 4)
    {0x8B, 4, 6, 0},      // Jcc(Near, 4)
    {0x8C, 4, 6, 0},      // Jcc(Near, 4)
    {0x8D, 4, 6, 0},      // Jcc(Near, 4)
    {0x8E, 4, 6, 0},      // Jcc(Near, 4)
    {0x8F, 4, 6, 0}       // Jcc(Near, 4)
};

int Opcode1ListsCount = sizeof(Opcode1Lists) / sizeof(OPCODELIST);
int Opcode2ListsCount = sizeof(Opcode2Lists) / sizeof(OPCODELIST);

// ޸ ּ Ķ͸ ޴ 쿡  ĶͰ Ѵ
// OPCODE.H  
int GetDisplacementCount(unsigned char *pCodeBytes, int CurrentEnv)
{
    unsigned char spec;
    unsigned char sib;

    spec = pCodeBytes[0];
    if (CurrentEnv == 16) {
        if ((spec & 0xC0) == 0xC0) {
	    	// oo == 11 ==> X
            return 0;
        }
        else if ((spec & 0xC0) == 0x00) {
            if ((spec & 0x07) == 0x06) {
				// oo == 00 && rrr == 110 ==> Disp16
                return 2;
            }
            // oo == 00 && rrr == 000 ==> X
            return 0;
        }
        else if ((spec & 0xC0) == 0x40) {
        	// oo == 01 ==> Disp8
            return 1;
        }
        // (spec & 0xC0) == 0x80
        // oo == 00 ==> Disp16
        return 2;
    }
    // CurrentEnv == 32
    if ((spec & 0xC0) == 0xC0) {
    	// oo == 11 ==> X
        return 0;
    }
    if ((spec & 0xC0) == 0x00) {
        if ((spec & 0x07) == 0x05) {
        	// oo == 00 && mmm == 101 ==> Disp32
            return 4;
        }
        if ((spec & 0x07) == 0x04) {
            sib = pCodeBytes[1];
            if ((sib & 0x07) == 0x05) {
	        	// oo == 00 && mmm == 100 && rrr == 101 ==> SIB + Disp32
                return 5;
            }
            // oo == 00 && mmm == 100 ==> SIB
            return 1;
        }
        // oo == 00 ==> X
        return 0;
    }
    if ((spec & 0xC0) == 0x40) {
        if ((spec & 0x07) == 0x04) {
        	// oo == 01 && mmm == 100 ==> SIB + Disp8
            return 2;
        }
        // oo == 01 ==> Disp8
        return 1;
    }
    // (spec & 0xC0) == 0x80
    if ((spec & 0x07) == 0x04) {
    	// oo == 10 && mmm == 100 ==> SIB + Disp32
        return 5;
    }
	// oo == 10 ==> Disp32
    return 4;
}

// CurrentEnv(16Ʈ or 32Ʈ) pCodeBytes ڵ忡
// Thresholdŭ ּ Ʈ ̻ ϴ  ũ⸦ Ѵ
int GetMinimumMemonicBytes(unsigned char *pCodeBytes, int Threshold, int CurrentEnv)
{
    unsigned char currentByte;
    unsigned char nextByte;
    int currentOffset = 0;
    int displacement = 0;
    int i;

    while (1) {
    	// Threshold currentOffset Ŀ Ѵ
        if (currentOffset >= Threshold) return currentOffset;
        displacement = 0;
        currentByte = pCodeBytes[currentOffset];
        // Test(3) Check(TEST Ưϰ мѴ)
        if (currentByte == 0xF6) {
            nextByte = pCodeBytes[currentOffset + 1];
            if ((nextByte & 0x38) == 0x00) {
                if (CurrentEnv == 16) {
                    displacement = GetDisplacementCount(pCodeBytes + currentOffset + 1, CurrentEnv);
                    currentOffset = currentOffset + 3 + displacement;  // Test(3)
                    continue;
                }
                if (CurrentEnv == 32) {
                    displacement = GetDisplacementCount(pCodeBytes + currentOffset + 1, CurrentEnv);
                    currentOffset = currentOffset + 3 + displacement;  // Test(3)
                    continue;
                }
            }
        }
        // Test(4) Check(TEST Ưϰ мѴ)
        if (currentByte == 0xF7) {
            nextByte = pCodeBytes[currentOffset + 1];
            if ((nextByte & 0x38) == 0x00) {
                if (CurrentEnv == 16) {
                    displacement = GetDisplacementCount(pCodeBytes + currentOffset + 1, CurrentEnv);
                    currentOffset = currentOffset + 4 + displacement;  // Test(4)
                    continue;
                }
                if (CurrentEnv == 32) {
                    displacement = GetDisplacementCount(pCodeBytes + currentOffset + 1, CurrentEnv);
                    currentOffset = currentOffset + 6 + displacement;  // Test(4)
                    continue;
                }
            }
        }
        // Opcode1 Check
        for (i = 0; i < Opcode1ListsCount; i++) {
            if (Opcode1Lists[i].Opcode == currentByte) {
                if (CurrentEnv == 16) {
                    if (Opcode1Lists[i].bAddressing == 1) {
                        displacement = GetDisplacementCount(pCodeBytes + currentOffset + 1, CurrentEnv);
                    }
                    currentOffset = currentOffset + Opcode1Lists[i].CommandCount16 + displacement;
                    break;
                }
                if (CurrentEnv == 32) {
                    if (Opcode1Lists[i].bAddressing == 1) {
                        displacement = GetDisplacementCount(pCodeBytes + currentOffset + 1, CurrentEnv);
                    }
                    currentOffset = currentOffset + Opcode1Lists[i].CommandCount32 + displacement;
                    break;
                }
            }
        }
        if (i != Opcode1ListsCount) continue;
        // Opcode2 Check
        if (currentByte == 0x0F) {
            nextByte = pCodeBytes[currentOffset + 1];
            for (i = 0; i < Opcode2ListsCount; i++) {
                if (Opcode2Lists[i].Opcode == nextByte) {
                    if (CurrentEnv == 16) {
                        if (Opcode2Lists[i].bAddressing == 1) {
                            displacement = GetDisplacementCount(pCodeBytes + currentOffset + 2, CurrentEnv);
                        }
                        currentOffset = currentOffset + Opcode2Lists[i].CommandCount16 + displacement;
                        break;
                    }
                    if (CurrentEnv == 32) {
                        if (Opcode2Lists[i].bAddressing == 1) {
                            displacement = GetDisplacementCount(pCodeBytes + currentOffset + 2, CurrentEnv);
                        }
                        currentOffset = currentOffset + Opcode2Lists[i].CommandCount32 + displacement;
                        break;
                    }
                }
            }
            if (i != Opcode2ListsCount) continue;
        }
        // FPU Opcode Check
        if (currentByte == 0xD8 ||
            currentByte == 0xD9 ||
            currentByte == 0xDA ||
            currentByte == 0xDB ||
            currentByte == 0xDC ||
            currentByte == 0xDD ||
            currentByte == 0xDE ||
            currentByte == 0xDF
        ) {
            displacement = GetDisplacementCount(pCodeBytes + currentOffset + 1, CurrentEnv);
            currentOffset = currentOffset + 2 + displacement;
            continue;
        }
        // DB XX
        currentOffset = currentOffset + 1;
    }
}

/*
void main(void)
{
    int count;
    // ׽Ʈ غ ڵ 
//    unsigned char TestCodes[] = { 0x55, 0x8B, 0xEC, 0x83, 0xEC, 0x18, 0x80, 0x65, 0xEC, 0x00, 0x80, 0x65, 0xFF, 0x00 };
//    unsigned char TestCodes[] = { 0x53, 0x55, 0x56, 0x57, 0xb9, 0x20, 0x02, 0xe5, 0xba, 0xe8, 0x74, 0xa0, 0xff, 0xff };

	// 32Ʈ ȯ濡 ּ 5Ʈ ŭ  ڵƮ Ѵ
    count = GetMinimumMemonicBytes(TestCodes, 5, 32);
    printf("# = %d", count);
}
*/


