#include <ntddk.h>        /* required for WDM driver development */
#include <stdarg.h>     /* standard io include files */
#include <stdio.h>

#include "devioctl.h"
#include <initguid.h>

#pragma optimize("", off)
#include "SAMPLE.h"    
#include "Power.h" // Power

/////////////////////////////////////////////////////////////////////////////////////////////
// RemoveLock Ȱϴ  Ÿϴ
// RemoveLock ȹϴ ȸ ݳϴ ȸ µ ؾ մϴ

// ȹϴ ũ(ȹ ϸ Irp ϴ ũ)
#define FOR_DISPATCH_ROUTINE_AT_IO_ACQUIRE_REMOVE_LOCK { \
	returnStatus = IoAcquireRemoveLock ( &deviceExtension->RemoveLock, (PVOID)POOL_TAG );\
	if (!NT_SUCCESS (returnStatus)) \
	{\
	    Irp->IoStatus.Status = returnStatus;\
	    Irp->IoStatus.Information = 0;\
	    IoCompleteRequest(Irp, IO_NO_INCREMENT);\
	    return returnStatus;\
	}\
}\

// ȹϴ ũ(Irp  ʴ ũ)
#define FOR_THREAD_ROUTINE_AT_IO_ACQUIRE_REMOVE_LOCK { \
	returnStatus = IoAcquireRemoveLock ( &deviceExtension->RemoveLock, (PVOID)POOL_TAG );\
	if (!NT_SUCCESS (returnStatus)) \
	{\
	    return;\
	}\
}\

// ȹϴ ũ
#define IO_ACQUIRE_REMOVE_LOCK { \
	IoAcquireRemoveLock ( &deviceExtension->RemoveLock, (PVOID)POOL_TAG );\
}\

// ݳϴ ũ
#define IO_RELEASE_REMOVE_LOCK { \
	IoReleaseRemoveLock ( &deviceExtension->RemoveLock, (PVOID)POOL_TAG );\
}\

// ݳϴ ũ, ݳغ RemoveLock  0 ƴϸ  ٸ ˴ϴ
#define IO_RELEASE_REMOVE_LOCK_TILL_END { \
	IoReleaseRemoveLockAndWait ( &deviceExtension->RemoveLock, (PVOID)POOL_TAG );\
}\

//
/////////////////////////////////////////////////////////////////////////////////////////////

void IrpStringOut( PIRP Irp ) // IRP Ʈմϴ
{
	KIRQL Irql;
	PIO_STACK_LOCATION pStack;
	
	pStack = IoGetCurrentIrpStackLocation( Irp );

	switch( pStack->MajorFunction )
	{
	case IRP_MJ_CREATE:
		DbgPrint("[IRP_MJ_CREATE]");
		break;
	case IRP_MJ_READ:
		DbgPrint("[IRP_MJ_READ]");
		break;
	case IRP_MJ_WRITE:
		DbgPrint("[IRP_MJ_WRITE]");
		break;
	case IRP_MJ_CLOSE:
		DbgPrint("[IRP_MJ_CLOSE]");
		break;
	case IRP_MJ_DEVICE_CONTROL:
		DbgPrint("[IRP_MJ_DEVICE_CONTROL]");
		DbgPrint("ControlCode = %8X", pStack->Parameters.DeviceIoControl.IoControlCode);
		break;
	case IRP_MJ_PNP:
		DbgPrint("[IRP_MJ_PNP]");
		switch( pStack->MinorFunction )
		{
			case IRP_MN_START_DEVICE:
				DbgPrint("IRP_MN_START_DEVICE");
				break;
			case IRP_MN_REMOVE_DEVICE:
				DbgPrint("IRP_MN_REMOVE_DEVICE");
				break;
			case IRP_MN_QUERY_CAPABILITIES:
				DbgPrint("IRP_MN_QUERY_CAPABILITIES");
				break;
			case IRP_MN_SURPRISE_REMOVAL:
				DbgPrint("IRP_MN_SURPRISE_REMOVAL");
				break;
			default:
				DbgPrint("ANY MN FUNCTION");
				break;
		}
		break;
	case IRP_MJ_POWER:
		DbgPrint("[IRP_MJ_POWER]");
		switch( pStack->MinorFunction )
		{
			case IRP_MN_SET_POWER:
				DbgPrint("IRP_MN_SET_POWER");
				break;
			case IRP_MN_QUERY_POWER:
				DbgPrint("IRP_MN_QUERY_POWER");
				break;
			default:
				DbgPrint("ANY MN FUNCTION");
				break;
		}
		break;
	default:
		DbgPrint("[ANY IRP] = 0x%8X\n", Irp );
		return;
	}
	DbgPrint("\n");
}

NTSTATUS                                                            
DriverEntry                                                         
	(                                                               
	IN PDRIVER_OBJECT DriverObject,             /* pointer to the device object */
	IN PUNICODE_STRING RegistryPath             /* pointer to a unicode string representing the path */
												/*    to the drivers specific key in the registry    */
	)// ̹ ޸𸮿 óϴ 쿡 ѹ ȣ˴ϴ
{
	NTSTATUS returnStatus = STATUS_SUCCESS;     /* stores status to be returned */

	DbgPrint("DriverEntry ++ \n" );

	DriverObject->DriverUnload = SAMPLE_Unload;
	DriverObject->DriverExtension->AddDevice = SAMPLE_AddDevice;
	DriverObject->MajorFunction[IRP_MJ_PNP] = SAMPLE_PnpDispatch;
	DriverObject->MajorFunction[IRP_MJ_POWER] = SAMPLE_PowerDispatch;

	DbgPrint("DriverEntry -- \n" );
	return returnStatus;
}

NTSTATUS
SAMPLE_AddDevice
	(
	IN PDRIVER_OBJECT DriverObject,         
	IN PDEVICE_OBJECT PhysicalDeviceObject  
	)// PNPManager ̰ ؼ IRP DeviceStack ϶ û մϴ
{
	/* IRP DeviceStack ϱ ؼ  ܰ踦 ġ ˴ϴ 
	1. DeviceObject۾
	2. ϴ DeviceStack DeviceObject ø
	3. DeviceObject Flag ϱ
	*/
	PDEVICE_EXTENSION deviceExtension;              
	NTSTATUS returnStatus = STATUS_SUCCESS;         
	PDEVICE_OBJECT DeviceObject = NULL;             
	ULONG dwRet;

	DbgPrint("SAMPLE_AddDevice ++ \n" );

	returnStatus = IoCreateDevice                                       
					(                                               
						DriverObject,                               
						sizeof ( DEVICE_EXTENSION ),                
						NULL,                   
						FILE_DEVICE_UNKNOWN,
						FILE_AUTOGENERATED_DEVICE_NAME,                                          
						FALSE,                                      
						&DeviceObject       
					);// DeviceObject մϴ

	if( !NT_SUCCESS( returnStatus ) )
	{
		DbgPrint("IoCreateDevice() Error, Status = %8X\n", returnStatus );
		goto SAMPLE_AddDevice_Exit;
	}

	deviceExtension = DeviceObject->DeviceExtension;

	RtlZeroMemory( deviceExtension, sizeof(DEVICE_EXTENSION));

	deviceExtension->PhysicalDeviceObject = PhysicalDeviceObject;
	
	deviceExtension->DeviceObject = DeviceObject;

	deviceExtension->NextLayerDeviceObject =
	IoAttachDeviceToDeviceStack (
							DeviceObject,
							PhysicalDeviceObject	
	);// ϴ DeviceStack DeviceObject øϴ

	DeviceObject->Flags |= deviceExtension->NextLayerDeviceObject->Flags & 
							( DO_POWER_PAGABLE  | DO_POWER_INRUSH); // DeviceObject Flag մϴ

	SET_MYDEVICE_POWER_STATE(PowerDeviceD3) // PowerManager  츮 ¸  ʽϴ.  츮 ϱ ؼ ϴ ũ

	DeviceObject->Flags &= ~DO_DEVICE_INITIALIZING; // DeviceObject Flag մϴ

	IoInitializeRemoveLock (&deviceExtension->RemoveLock, POOL_TAG, 0, 0); //  RemoveLock غմϴ. 

SAMPLE_AddDevice_Exit:
	DbgPrint("SAMPLE_AddDevice -- \n" );
	return returnStatus;
}

VOID                                                                
SAMPLE_Unload                                                       
	(                                                               
	IN PDRIVER_OBJECT DriverObject  /* pointer to device object */
	)
{// ̻ ̹  DeviceObject  ̰ ȣ, ̹ ޸𸮿 ŵ˴ϴ

	DbgPrint("SAMPLE_Unload ++ \n" );

	// Do job..

	DbgPrint("SAMPLE_Unload -- \n" );
}

NTSTATUS
SAMPLE_DeferIrpCompletion
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to a device object */
	IN PIRP Irp,                        /* pointer to a I/O request packet */
	IN PVOID Context                    /* driver defined context */
	)// ɾ IRP NextLayer ̹ IoCompleteRequest()Լ ؼ ûǴ 쿡 ȣ˴ϴ
{
	PKEVENT event = Context;    /* kernel event passed in Context */

	DbgPrint("SAMPLE_DeferIrpCompletion ++ \n" );

	KeSetEvent(event,
			   1,
			   FALSE);

	
	DbgPrint("SAMPLE_DeferIrpCompletion -- \n" );

	return STATUS_MORE_PROCESSING_REQUIRED; // IoCompleteRequest()Լ Ͽ,  IRP  ߴ϶ û մϴ
}

NTSTATUS
IrpCapablitiesCompletionRoutine
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to a device object */
	IN PIRP Irp,                        /* pointer to a I/O request packet */
	IN PVOID Context                    /* driver defined context */
	)
{ // ̹ ÷ִ Powerå Map Table ȹϱ ؼ غմϴ
	NTSTATUS Status;
	PDEVICE_EXTENSION deviceExtension;
	PIO_STACK_LOCATION pStack;
	PDEVICE_CAPABILITIES pCapabilities;

	deviceExtension = DeviceObject->DeviceExtension;
		
	if( Irp->PendingReturned )
		IoMarkIrpPending( Irp );

	pStack = IoGetCurrentIrpStackLocation( Irp );
	pStack->Parameters.DeviceCapabilities.Capabilities->SurpriseRemovalOK = TRUE;
	pCapabilities = (PDEVICE_CAPABILITIES)pStack->Parameters.DeviceCapabilities.Capabilities;

	memcpy( &deviceExtension->DeviceCaps, pCapabilities, sizeof(DEVICE_CAPABILITIES) ); // ̹ ÷ִ  մϴ

	return Irp->IoStatus.Status;
}

NTSTATUS
SAMPLE_PnpDispatch
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	)
{// PNPManager  IRP óϴ ó
	PIO_STACK_LOCATION pStack;                /* pointer to IRP stack */
	PDEVICE_EXTENSION deviceExtension;          /* pointer to device extention */
	NTSTATUS returnStatus = STATUS_SUCCESS;     /* stores status to be returned */
	PDEVICE_OBJECT NextLayerDeviceObject;           /* pointer to the stack device object */
	
	DbgPrint("SAMPLE_PnpDispatch ++ \n" );

	IrpStringOut( Irp );

	pStack = IoGetCurrentIrpStackLocation ( Irp );
	deviceExtension = DeviceObject->DeviceExtension;
	FOR_DISPATCH_ROUTINE_AT_IO_ACQUIRE_REMOVE_LOCK // ̿  Լۺκп ׻ LOCK ȹϴ    ϴ

	NextLayerDeviceObject = deviceExtension->NextLayerDeviceObject;
			
	switch ( pStack->MinorFunction )
	{
		case IRP_MN_START_DEVICE :
		{// DeviceStack ϶ 㰡 ǹմϴ
			KEVENT event;   /* event used to wait for an operation to complete */
			KeInitializeEvent(&event, NotificationEvent, FALSE);
			IoCopyCurrentIrpStackLocationToNext(Irp);  
			IoSetCompletionRoutine(Irp,
								   SAMPLE_DeferIrpCompletion,
								   &event,
								   TRUE,
								   TRUE,
								   TRUE); // SAMPLE_DeferIrpCompletion()Լ  IRP  Next Layer Driver ȣϴ
										  // IoCompleteRequest()Լ ؼ ȣǵ մϴ
			
			returnStatus = IoCallDriver(NextLayerDeviceObject,Irp); // NextLayer Driver   ѵ,  Ȯմϴ
			if (returnStatus == STATUS_PENDING) 
			{
				KeWaitForSingleObject(
					&event,
					Executive,
					KernelMode,
					FALSE,
					NULL);
				returnStatus = Irp->IoStatus.Status;
			}
			if( !NT_SUCCESS( returnStatus ) )
			{
				DbgPrint("Start Device Fail\n" );
				IoCompleteRequest( Irp, IO_NO_INCREMENT );
				IO_RELEASE_REMOVE_LOCK // ݵ Լ   RemoveLock  ҽѾ մϴ
				goto SAMPLE_PnpDispatch_Exit;
			}
			// NextLayer Driver    ٷ, 츮 ΰ ص ٴ ǹԴϴ

			// Do Job...
			SET_MYDEVICE_POWER_STATE(PowerDeviceD0) // PowerManager  츮 ¸  ʽϴ.  츮 ϱ ؼ ϴ ũ

			IoCompleteRequest( Irp, IO_NO_INCREMENT ); //  IRP ûմϴ
			// SAMPLE_DeferIrpCompletion()Լ 츮 IRP  Next Layer Driver ȣ IoCompleteRequest() 
		}	// ϵ "STATUS_MORE_PROCESSING_REQUIRED" ױ⶧, 츮 û ؾմϴ
		IO_RELEASE_REMOVE_LOCK // ݵ Լ   RemoveLock  ҽѾ մϴ
		break;

	    case IRP_MN_QUERY_CAPABILITIES:
			{ // ̹   óϸ, Powerå  Map Table ÷ְ ˴ϴ.
			/* pass it to our PDO */
			IoCopyCurrentIrpStackLocationToNext(Irp);  
			IoSetCompletionRoutine(Irp,
							   IrpCapablitiesCompletionRoutine, // Map Table  ؼ ϴ ߴ
							   NULL,
							   TRUE,
							   TRUE,
							   TRUE);
			returnStatus = IoCallDriver(NextLayerDeviceObject, Irp);
			IO_RELEASE_REMOVE_LOCK	 // ݵ Լ   RemoveLock  ҽѾ մϴ		
		}
		break;

		case IRP_MN_SURPRISE_REMOVAL :
			{ // ڱ ġ PC ŵǾٴ ǹ̿ ޵˴ϴ
			Irp->IoStatus.Status = STATUS_SUCCESS;
			IoSkipCurrentIrpStackLocation( Irp ); //  IRP  ɶ ̻   ʰڴٴ ǹԴϴ
			returnStatus = IoCallDriver(NextLayerDeviceObject, Irp);
			IO_RELEASE_REMOVE_LOCK // ݵ Լ   RemoveLock  ҽѾ մϴ
		}
		break;

		case IRP_MN_REMOVE_DEVICE :
			{ // IRP DeviceStack ü϶ û ǹ̷ ޵˴ϴ
			IO_RELEASE_REMOVE_LOCK_TILL_END // RemoveLock  ҽŲ, 0 ƴϸ ӱٸ ˴ϴ

			SET_MYDEVICE_POWER_STATE(PowerDeviceD3) // PowerManager  츮 ¸  ʽϴ.  츮 ϱ ؼ ϴ ũ

			IoDetachDevice ( NextLayerDeviceObject );// Next Layer Driver  켱 ϴ
													 // SAMPLE_AddDevice() IoAttachDeviceToDeviceStack()Լ ݴǹ
			IoDeleteDevice ( DeviceObject );		 // 츮 DeviceObject մϴ
													 // SAMPLE_AddDevice() IoCreateDevice()Լ ݴǹ
			Irp->IoStatus.Status = STATUS_SUCCESS;
			IoSkipCurrentIrpStackLocation( Irp ); //  IRP  ɶ ̻   ʰڴٴ ǹԴϴ
			returnStatus = IoCallDriver(NextLayerDeviceObject, Irp);
		}
		break;

		default:
		{
			IoSkipCurrentIrpStackLocation( Irp ); //  IRP  ɶ ̻   ʰڴٴ ǹԴϴ
			returnStatus = IoCallDriver(NextLayerDeviceObject, Irp);
			IO_RELEASE_REMOVE_LOCK // ݵ Լ   RemoveLock  ҽѾ մϴ
		}
		break;
	} 

SAMPLE_PnpDispatch_Exit:
	DbgPrint("SAMPLE_PnpDispatch -- \n" );

	return returnStatus;
}

void SpeakerOn()
{
	unsigned char cData;

	cData = READ_PORT_UCHAR( (PVOID)0x61 );
	cData |= 0x03;
	WRITE_PORT_UCHAR( (PVOID)0x61, cData );
}

void SpeakerOff()
{
	unsigned char cData;

	cData = READ_PORT_UCHAR( (PVOID)0x61 );
	cData &= ~0x03;
	WRITE_PORT_UCHAR( (PVOID)0x61, cData );
}

void Beep( ULONG Frequency )
{
	unsigned short wData;

	wData = (unsigned short)(1191318L / Frequency);

	WRITE_PORT_UCHAR( (PVOID)0x43, 0xB6 );

	WRITE_PORT_UCHAR( (PVOID)0x42, (unsigned char)(wData & 0x00FF) );
	WRITE_PORT_UCHAR( (PVOID)0x42, (unsigned char)(wData >> 8) );
}

void Delay( ULONG msecTime )
{
	KeStallExecutionProcessor( msecTime * 1000 );	
}

NTSTATUS PowerChangeNotificationRoutine( PDEVICE_OBJECT DeviceObject, DEVICE_POWER_STATE OldState, DEVICE_POWER_STATE NewState )
{ // Power° Ǹ ׻ ȣ˴ϴ. ref) power.c
	int Frequency;

	if( NewState < OldState ) // Low -> High
	{
		SpeakerOn();
		
		for( Frequency = 100 ; Frequency < 10000 ; Frequency += 500 )
		{
			Beep( Frequency );
			Delay( 200 );
		}

		SpeakerOff();
	}			
	else if( NewState > OldState ) // Low <- High
	{
		SpeakerOn();

		for( Frequency = 10000 ; Frequency > 100 ; Frequency -= 500 )
		{
			Beep( Frequency );
			Delay( 200 );
		}

		SpeakerOff();
	}			
	return STATUS_SUCCESS;
}
