#include <ntddk.H>

#ifndef _SAMPLE_
#define _SAMPLE_

typedef struct _DEVICE_EXTENSION 
{
	PDEVICE_OBJECT PhysicalDeviceObject; /* physical device object */
	PDEVICE_OBJECT NextLayerDeviceObject; /* Next Layer device object */
	PDEVICE_OBJECT DeviceObject; /* Self device object */
	UNICODE_STRING UnicodeString; 
	// ڿ  DeviceStack  ̸ ϴ°

	KDPC MyDpc;
	KTIMER MyTimer;

	PKINTERRUPT InterruptObject;
	int InterruptVector;
	KSPIN_LOCK SpinLock; // DPCƾ CancelSpinLock ϹǷ ʿ ʴ
}DEVICE_EXTENSION, *PDEVICE_EXTENSION;

void
ISR_DPC_StartIo
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	);

VOID
MyDpcRoutine(
    IN PKDPC Dpc,
    IN PVOID DeferredContext,
    IN PVOID SystemArgument1,
    IN PVOID SystemArgument2
    );

NTSTATUS
ISR_DPC_AddDevice
	(
	IN PDRIVER_OBJECT DriverObject,         
	IN PDEVICE_OBJECT PhysicalDeviceObject  
	);

VOID                                                                
ISR_DPC_Unload                                                       
	(                                                               
	IN PDRIVER_OBJECT DriverObject  /* pointer to device object */
	);

NTSTATUS
ISR_DPC_DeferIrpCompletion
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to a device object */
	IN PIRP Irp,                        /* pointer to a I/O request packet */
	IN PVOID Context                    /* driver defined context */
	);

NTSTATUS
ISR_DPC_Create
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	);

NTSTATUS                                                            
ISR_DPC_Cleanup
	(                                                               
		IN PDEVICE_OBJECT DeviceObject,                             
		IN PIRP Irp                                                 
	);

NTSTATUS
ISR_DPC_Close
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	);

NTSTATUS
ISR_DPC_PnpDispatch
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	);

NTSTATUS
ISR_DPC_PowerDispatch
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	);

NTSTATUS
ISR_DPC_DeviceIoControl
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	);

#endif //_SAMPLE_
